/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataCloudflareGatewayAppTypesConfig extends cdktf.TerraformMetaArguments {
    /**
    * The account ID to fetch Gateway App Types from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/4.46.0/docs/data-sources/gateway_app_types#account_id DataCloudflareGatewayAppTypes#account_id}
    */
    readonly accountId: string;
}
export interface DataCloudflareGatewayAppTypesAppTypes {
}
export declare function dataCloudflareGatewayAppTypesAppTypesToTerraform(struct?: DataCloudflareGatewayAppTypesAppTypes): any;
export declare function dataCloudflareGatewayAppTypesAppTypesToHclTerraform(struct?: DataCloudflareGatewayAppTypesAppTypes): any;
export declare class DataCloudflareGatewayAppTypesAppTypesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataCloudflareGatewayAppTypesAppTypes | undefined;
    set internalValue(value: DataCloudflareGatewayAppTypesAppTypes | undefined);
    get applicationTypeId(): number;
    get description(): string;
    get id(): number;
    get name(): string;
}
export declare class DataCloudflareGatewayAppTypesAppTypesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataCloudflareGatewayAppTypesAppTypesOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/cloudflare/cloudflare/4.46.0/docs/data-sources/gateway_app_types cloudflare_gateway_app_types}
*/
export declare class DataCloudflareGatewayAppTypes extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "cloudflare_gateway_app_types";
    /**
    * Generates CDKTF code for importing a DataCloudflareGatewayAppTypes resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataCloudflareGatewayAppTypes to import
    * @param importFromId The id of the existing DataCloudflareGatewayAppTypes that should be imported. Refer to the {@link https://registry.terraform.io/providers/cloudflare/cloudflare/4.46.0/docs/data-sources/gateway_app_types#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataCloudflareGatewayAppTypes to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/cloudflare/cloudflare/4.46.0/docs/data-sources/gateway_app_types cloudflare_gateway_app_types} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataCloudflareGatewayAppTypesConfig
    */
    constructor(scope: Construct, id: string, config: DataCloudflareGatewayAppTypesConfig);
    private _accountId?;
    get accountId(): string;
    set accountId(value: string);
    get accountIdInput(): string | undefined;
    private _appTypes;
    get appTypes(): DataCloudflareGatewayAppTypesAppTypesList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
