/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataCloudflareGatewayCategoriesConfig extends cdktf.TerraformMetaArguments {
    /**
    * The account ID to fetch Gateway Categories from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/4.46.0/docs/data-sources/gateway_categories#account_id DataCloudflareGatewayCategories#account_id}
    */
    readonly accountId: string;
}
export interface DataCloudflareGatewayCategoriesCategoriesSubcategories {
}
export declare function dataCloudflareGatewayCategoriesCategoriesSubcategoriesToTerraform(struct?: DataCloudflareGatewayCategoriesCategoriesSubcategories): any;
export declare function dataCloudflareGatewayCategoriesCategoriesSubcategoriesToHclTerraform(struct?: DataCloudflareGatewayCategoriesCategoriesSubcategories): any;
export declare class DataCloudflareGatewayCategoriesCategoriesSubcategoriesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataCloudflareGatewayCategoriesCategoriesSubcategories | undefined;
    set internalValue(value: DataCloudflareGatewayCategoriesCategoriesSubcategories | undefined);
    get beta(): cdktf.IResolvable;
    get class(): string;
    get description(): string;
    get id(): number;
    get name(): string;
}
export declare class DataCloudflareGatewayCategoriesCategoriesSubcategoriesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataCloudflareGatewayCategoriesCategoriesSubcategoriesOutputReference;
}
export interface DataCloudflareGatewayCategoriesCategories {
}
export declare function dataCloudflareGatewayCategoriesCategoriesToTerraform(struct?: DataCloudflareGatewayCategoriesCategories): any;
export declare function dataCloudflareGatewayCategoriesCategoriesToHclTerraform(struct?: DataCloudflareGatewayCategoriesCategories): any;
export declare class DataCloudflareGatewayCategoriesCategoriesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataCloudflareGatewayCategoriesCategories | undefined;
    set internalValue(value: DataCloudflareGatewayCategoriesCategories | undefined);
    get beta(): cdktf.IResolvable;
    get class(): string;
    get description(): string;
    get id(): number;
    get name(): string;
    private _subcategories;
    get subcategories(): DataCloudflareGatewayCategoriesCategoriesSubcategoriesList;
}
export declare class DataCloudflareGatewayCategoriesCategoriesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataCloudflareGatewayCategoriesCategoriesOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/cloudflare/cloudflare/4.46.0/docs/data-sources/gateway_categories cloudflare_gateway_categories}
*/
export declare class DataCloudflareGatewayCategories extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "cloudflare_gateway_categories";
    /**
    * Generates CDKTF code for importing a DataCloudflareGatewayCategories resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataCloudflareGatewayCategories to import
    * @param importFromId The id of the existing DataCloudflareGatewayCategories that should be imported. Refer to the {@link https://registry.terraform.io/providers/cloudflare/cloudflare/4.46.0/docs/data-sources/gateway_categories#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataCloudflareGatewayCategories to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/cloudflare/cloudflare/4.46.0/docs/data-sources/gateway_categories cloudflare_gateway_categories} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataCloudflareGatewayCategoriesConfig
    */
    constructor(scope: Construct, id: string, config: DataCloudflareGatewayCategoriesConfig);
    private _accountId?;
    get accountId(): string;
    set accountId(value: string);
    get accountIdInput(): string | undefined;
    private _categories;
    get categories(): DataCloudflareGatewayCategoriesCategoriesList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
